#Uncomment the parts relevant to 'destroy' if you need them
#DEPLOY
include:
  - project: 'ccsolutions.io/open-source/templates/terraform'
    file: 'Terraform.gitlab-ci.yml'

#DESTROY
#include:
#  - project: 'ccsolutions.io/open-source/templates/terraform'
#    file: 'Terraform.destroy.gitlab-ci.yml'

stages:
  - init
  - lint
  - validate
  - plan
  - build
  - deploy
#  - destroy

init:
  environment:
    name: sandbox
  extends: .terraform:init

lint:
  environment:
    name: sandbox
  extends: .terraform:lint

validate:
  environment:
    name: sandbox
  extends: .terraform:validate

plan:
  environment:
    name: sandbox
  extends: .terraform:plan
 only:
   refs:
     - main
  rules:
    - if: '$PHASE == "CREATE"'

build:
  environment:
    name: sandbox
  extends: .terraform:apply
  dependencies:
    - plan
 only:
   refs:
     - main
  rules:
    - if: '$PHASE == "CREATE"'

deploy:
  environment:
    name: sandbox
  extends: .terraform:deploy
  dependencies:
    - build
 only:
   refs:
     - main
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
    - if: '$PHASE == "CREATE"'

#destroy:
#  environment:
#    name: sandbox
#  extends: .terraform:destroy
#  dependencies:
#    - build
# only:
#   refs:
#     - main
#  rules:
#    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
#    - if: '$PHASE == "DESTROY"'
